| Cantera 3.0.0

Loading...
Searching...
No Matches
Public Member Functions | Protected Attributes | List of all members
PDSS Class Reference
Thermodynamic Properties » Species Standard-State Thermodynamic Properties

Virtual base class for a species with a pressure dependent standard state. More...

`#include <PDSS.h>`

Inheritance diagram for PDSS:
[legend]

## Detailed Description

Virtual base class for a species with a pressure dependent standard state.

Virtual base class for calculation of the pressure dependent standard state for a single species

Class PDSS is the base class for a family of classes that compute properties of a set of species in their standard states at a range of temperatures and pressures. The independent variables for this object are temperature and pressure. The class may have a reference to a SpeciesThermoInterpType object which handles the calculation of the reference state temperature behavior of the species.

This class is analogous to the SpeciesThermoInterpType class, except that the standard state inherently incorporates the pressure dependence.

The class operates on a setState temperature and pressure basis. It only recalculates the standard state when the setState functions for temperature and pressure are called.

Definition at line 146 of file PDSS.h.

## Public Member Functions
virtual void | setTemperature (double temp)
| Set the internal temperature.
virtual double | temperature () const
| Return the current stored temperature.
virtual void | setState_TP (double temp, double pres)
| Set the internal temperature and pressure.
virtual void | setState_TR (double temp, double rho)
| Set the internal temperature and density.
virtual double | critTemperature () const
| critical temperature
virtual double | critPressure () const
| critical pressure
virtual double | critDensity () const
| critical density
virtual double | satPressure (double T)
| saturation pressure
double | molecularWeight () const
| Return the molecular weight of the species in units of kg kmol-1.
void | setMolecularWeight (double mw)
| Set the molecular weight of the species.
Constructors
| PDSS ()=default
| Default Constructor.
| PDSS (const PDSS &b)=delete
PDSS & | operator= (const PDSS &b)=delete
Molar Thermodynamic Properties of the Species Standard State
virtual double | enthalpy_mole () const
| Return the molar enthalpy in units of J kmol-1.
virtual double | enthalpy_RT () const
| Return the standard state molar enthalpy divided by RT.
virtual double | intEnergy_mole () const
| Return the molar internal Energy in units of J kmol-1.
virtual double | entropy_mole () const
| Return the molar entropy in units of J kmol-1 K-1.
virtual double | entropy_R () const
| Return the standard state entropy divided by RT.
virtual double | gibbs_mole () const
| Return the molar Gibbs free energy in units of J kmol-1.
virtual double | gibbs_RT () const
| Return the molar Gibbs free energy divided by RT.
virtual double | cp_mole () const
| Return the molar const pressure heat capacity in units of J kmol-1 K-1.
virtual double | cp_R () const
| Return the molar const pressure heat capacity divided by RT.
virtual double | cv_mole () const
| Return the molar const volume heat capacity in units of J kmol-1 K-1.
virtual double | molarVolume () const
| Return the molar volume at standard state.
virtual double | density () const
| Return the standard state density at standard state.
virtual double | enthalpyDelp_mole () const
| Get the difference in the standard state enthalpy between the current pressure and the reference pressure, p0.
virtual double | entropyDelp_mole () const
| Get the difference in the standard state entropy between the current pressure and the reference pressure, p0.
virtual double | gibbsDelp_mole () const
| Get the difference in the standard state Gibbs free energy between the current pressure and the reference pressure, p0.
virtual double | cpDelp_mole () const
| Get the difference in standard state heat capacity between the current pressure and the reference pressure, p0.
Properties of the Reference State of the Species in the Solution
double | refPressure () const
| Return the reference pressure for this phase.
double | minTemp () const
| return the minimum temperature
double | maxTemp () const
| return the minimum temperature
virtual double | gibbs_RT_ref () const
| Return the molar Gibbs free energy divided by RT at reference pressure.
virtual double | enthalpy_RT_ref () const
| Return the molar enthalpy divided by RT at reference pressure.
virtual double | entropy_R_ref () const
| Return the molar entropy divided by R at reference pressure.
virtual double | cp_R_ref () const
| Return the molar heat capacity divided by R at reference pressure.
virtual double | molarVolume_ref () const
| Return the molar volume at reference pressure.
Mechanical Equation of State Properties
virtual double | pressure () const
| Returns the pressure (Pa)
virtual void | setPressure (double pres)
| Sets the pressure in the object.
virtual double | thermalExpansionCoeff () const
| Return the volumetric thermal expansion coefficient. Units: 1/K.
Initialization of the Object
void | setReferenceThermo (shared_ptr< SpeciesThermoInterpType > stit)
| Set the SpeciesThermoInterpType object used to calculate reference state properties.
virtual void | setParent (VPStandardStateTP *phase, size_t k)
| Set the parent VPStandardStateTP object of this PDSS object.
virtual void | initThermo ()
| Initialization routine.
void | setParameters (const AnyMap &node)
| Set model parameters from an AnyMap phase description, for example from the `equation-of-state` field of a species definition.
virtual void | getParameters (AnyMap &eosNode) const
| Store the parameters needed to reconstruct a copy of this PDSS object.
virtual void | reportParams (size_t &kindex, int &type, double *const c, double &minTemp, double &maxTemp, double &refPressure) const
| This utility function reports back the type of parameterization and all of the parameters for the species, index.

## Protected Attributes
double | m_temp = -1.0
| Current temperature used by the PDSS object.
double | m_pres = -1.0
| State of the system - pressure.
double | m_p0 = -1.0
| Reference state pressure of the species.
double | m_minTemp = -1.0
| Minimum temperature.
double | m_maxTemp = 10000.0
| Maximum temperature.
double | m_mw = 0.0
| Molecular Weight of the species.
AnyMap | m_input
| Input data supplied via setParameters.
shared_ptr< SpeciesThermoInterpType > | m_spthermo
| Pointer to the species thermodynamic property manager.

## Constructor & Destructor Documentation

## ◆ PDSS()

PDSS | ( |  | ) |
| default

Default Constructor.

## Member Function Documentation

## ◆ enthalpy_mole()

double enthalpy_mole | ( |  | ) | const
| virtual

Return the molar enthalpy in units of J kmol-1.

Returns
  the species standard state enthalpy in J kmol-1 at the current temperature and pressure.

Reimplemented in PDSS_Nondimensional, PDSS_HKFT, and PDSS_Water.

Definition at line 18 of file PDSS.cpp.

## ◆ enthalpy_RT()

double enthalpy_RT | ( |  | ) | const
| virtual

Return the standard state molar enthalpy divided by RT.

Returns
  The dimensionless species standard state enthalpy divided at the current temperature and pressure.

Reimplemented in PDSS_Molar, PDSS_Nondimensional, and PDSS_IonsFromNeutral.

Definition at line 23 of file PDSS.cpp.

## ◆ intEnergy_mole()

double intEnergy_mole | ( |  | ) | const
| virtual

Return the molar internal Energy in units of J kmol-1.

Returns
  The species standard state internal Energy in J kmol-1 at the current temperature and pressure.

Reimplemented in PDSS_ConstVol, PDSS_HKFT, PDSS_IdealGas, PDSS_IonsFromNeutral, PDSS_SSVol, and PDSS_Water.

Definition at line 28 of file PDSS.cpp.

## ◆ entropy_mole()

double entropy_mole | ( |  | ) | const
| virtual

Return the molar entropy in units of J kmol-1 K-1.

Returns
  The species standard state entropy in J kmol-1 K-1 at the current temperature and pressure.

Reimplemented in PDSS_Nondimensional, PDSS_HKFT, and PDSS_Water.

Definition at line 33 of file PDSS.cpp.

## ◆ entropy_R()

double entropy_R | ( |  | ) | const
| virtual

Return the standard state entropy divided by RT.

Returns
  The species standard state entropy divided by RT at the current temperature and pressure.

Reimplemented in PDSS_Molar, PDSS_Nondimensional, and PDSS_IonsFromNeutral.

Definition at line 38 of file PDSS.cpp.

## ◆ gibbs_mole()

double gibbs_mole | ( |  | ) | const
| virtual

Return the molar Gibbs free energy in units of J kmol-1.

Returns
  The species standard state Gibbs free energy in J kmol-1 at the current temperature and pressure.

Reimplemented in PDSS_Nondimensional, PDSS_HKFT, and PDSS_Water.

Definition at line 43 of file PDSS.cpp.

## ◆ gibbs_RT()

double gibbs_RT | ( |  | ) | const
| virtual

Return the molar Gibbs free energy divided by RT.

Returns
  The species standard state Gibbs free energy divided by RT at the current temperature and pressure.

Reimplemented in PDSS_Molar, PDSS_Nondimensional, and PDSS_IonsFromNeutral.

Definition at line 48 of file PDSS.cpp.

## ◆ cp_mole()

double cp_mole | ( |  | ) | const
| virtual

Return the molar const pressure heat capacity in units of J kmol-1 K-1.

Returns
  The species standard state Cp in J kmol-1 K-1 at the current temperature and pressure.

Reimplemented in PDSS_Nondimensional, PDSS_HKFT, and PDSS_Water.

Definition at line 53 of file PDSS.cpp.

## ◆ cp_R()

double cp_R | ( |  | ) | const
| virtual

Return the molar const pressure heat capacity divided by RT.

Returns
  The species standard state Cp divided by RT at the current temperature and pressure.

Reimplemented in PDSS_Molar, PDSS_Nondimensional, and PDSS_IonsFromNeutral.

Definition at line 58 of file PDSS.cpp.

## ◆ cv_mole()

double cv_mole | ( |  | ) | const
| virtual

Return the molar const volume heat capacity in units of J kmol-1 K-1.

Returns
  The species standard state Cv in J kmol-1 K-1 at the current temperature and pressure.

Reimplemented in PDSS_ConstVol, PDSS_IdealGas, PDSS_SSVol, and PDSS_Water.

Definition at line 73 of file PDSS.cpp.

## ◆ molarVolume()

double molarVolume | ( |  | ) | const
| virtual

Return the molar volume at standard state.

Returns
  The standard state molar volume at the current temperature and pressure. Units are m**3 kmol-1.

Reimplemented in PDSS_Nondimensional, PDSS_HKFT, PDSS_IonsFromNeutral, and PDSS_Water.

Definition at line 63 of file PDSS.cpp.

## ◆ density()

double density | ( |  | ) | const
| virtual

Return the standard state density at standard state.

Returns
  The standard state density at the current temperature and pressure. units are kg m-3

Reimplemented in PDSS_Nondimensional, PDSS_HKFT, PDSS_IonsFromNeutral, and PDSS_Water.

Definition at line 68 of file PDSS.cpp.

## ◆ enthalpyDelp_mole()

double enthalpyDelp_mole | ( |  | ) | const
| virtual

Get the difference in the standard state enthalpy between the current pressure and the reference pressure, p0.

Deprecated:
  To be removed after Cantera 3.0

Definition at line 103 of file PDSS.cpp.

## ◆ entropyDelp_mole()

double entropyDelp_mole | ( |  | ) | const
| virtual

Get the difference in the standard state entropy between the current pressure and the reference pressure, p0.

Deprecated:
  To be removed after Cantera 3.0

Definition at line 109 of file PDSS.cpp.

## ◆ gibbsDelp_mole()

double gibbsDelp_mole | ( |  | ) | const
| virtual

Get the difference in the standard state Gibbs free energy between the current pressure and the reference pressure, p0.

Deprecated:
  To be removed after Cantera 3.0

Definition at line 115 of file PDSS.cpp.

## ◆ cpDelp_mole()

double cpDelp_mole | ( |  | ) | const
| virtual

Get the difference in standard state heat capacity between the current pressure and the reference pressure, p0.

Deprecated:
  To be removed after Cantera 3.0

Definition at line 121 of file PDSS.cpp.

## ◆ refPressure()

double refPressure | ( |  | ) | const
| inline

Return the reference pressure for this phase.

Definition at line 273 of file PDSS.h.

## ◆ minTemp()

double minTemp | ( |  | ) | const
| inline

return the minimum temperature

Definition at line 278 of file PDSS.h.

## ◆ maxTemp()

double maxTemp | ( |  | ) | const
| inline

return the minimum temperature

Definition at line 283 of file PDSS.h.

## ◆ gibbs_RT_ref()

double gibbs_RT_ref | ( |  | ) | const
| virtual

Return the molar Gibbs free energy divided by RT at reference pressure.

Returns
  The reference state Gibbs free energy at the current temperature, divided by RT.

Reimplemented in PDSS_Nondimensional, PDSS_HKFT, PDSS_IonsFromNeutral, and PDSS_Water.

Definition at line 78 of file PDSS.cpp.

## ◆ enthalpy_RT_ref()

double enthalpy_RT_ref | ( |  | ) | const
| virtual

Return the molar enthalpy divided by RT at reference pressure.

Returns
  The species reference state enthalpy at the current temperature, divided by RT.

Reimplemented in PDSS_Nondimensional, PDSS_HKFT, PDSS_IonsFromNeutral, and PDSS_Water.

Definition at line 83 of file PDSS.cpp.

## ◆ entropy_R_ref()

double entropy_R_ref | ( |  | ) | const
| virtual

Return the molar entropy divided by R at reference pressure.

Returns
  The species reference state entropy at the current temperature, divided by R.

Reimplemented in PDSS_Nondimensional, PDSS_HKFT, PDSS_IonsFromNeutral, and PDSS_Water.

Definition at line 88 of file PDSS.cpp.

## ◆ cp_R_ref()

double cp_R_ref | ( |  | ) | const
| virtual

Return the molar heat capacity divided by R at reference pressure.

Returns
  The species reference state heat capacity divided by R at the current temperature.

Reimplemented in PDSS_Nondimensional, PDSS_HKFT, PDSS_IonsFromNeutral, and PDSS_Water.

Definition at line 93 of file PDSS.cpp.

## ◆ molarVolume_ref()

double molarVolume_ref | ( |  | ) | const
| virtual

Return the molar volume at reference pressure.

Returns
  The reference state molar volume. units are m**3 kmol-1.

Reimplemented in PDSS_Nondimensional, PDSS_HKFT, PDSS_IonsFromNeutral, and PDSS_Water.

Definition at line 98 of file PDSS.cpp.

## ◆ pressure()

double pressure | ( |  | ) | const
| virtual

Returns the pressure (Pa)

Reimplemented in PDSS_IdealGas, and PDSS_Water.

Definition at line 127 of file PDSS.cpp.

## ◆ setPressure()

void setPressure | ( | double | pres | ) |
| virtual

Sets the pressure in the object.

Currently, this sets the pressure in the PDSS object. It is indeterminant what happens to the owning VPStandardStateTP object.

Parameters

  pres | Pressure to be set (Pascal)

Reimplemented in PDSS_ConstVol, PDSS_IdealGas, PDSS_SSVol, and PDSS_Water.

Definition at line 152 of file PDSS.cpp.

## ◆ thermalExpansionCoeff()

double thermalExpansionCoeff | ( |  | ) | const
| virtual

Return the volumetric thermal expansion coefficient. Units: 1/K.

The thermal expansion coefficient is defined as

\[ \beta = \frac{1}{v}\left(\frac{\partial v}{\partial T}\right)_P \]

Reimplemented in PDSS_Water.

Definition at line 132 of file PDSS.cpp.

## ◆ setTemperature()

void setTemperature | ( | double | temp | ) |
| virtual

Set the internal temperature.

Parameters

  temp | Temperature (Kelvin)

Reimplemented in PDSS_ConstVol, PDSS_IdealGas, PDSS_SSVol, and PDSS_Water.

Definition at line 162 of file PDSS.cpp.

## ◆ temperature()

double temperature | ( |  | ) | const
| virtual

Return the current stored temperature.

Definition at line 157 of file PDSS.cpp.

## ◆ setState_TP()

void setState_TP | ( | double | temp,
|  | double | pres
| ) |  |
| virtual

Set the internal temperature and pressure.

Parameters

  temp | Temperature (Kelvin)
  pres | pressure (Pascals)

Reimplemented in PDSS_ConstVol, PDSS_HKFT, PDSS_IdealGas, PDSS_IonsFromNeutral, PDSS_SSVol, and PDSS_Water.

Definition at line 176 of file PDSS.cpp.

## ◆ setState_TR()

void setState_TR | ( | double | temp,
|  | double | rho
| ) |  |
| virtual

Set the internal temperature and density.

Parameters

  temp | Temperature (Kelvin)
  rho | Density (kg m-3)

Deprecated:
  To be removed after Cantera 3.0

Reimplemented in PDSS_ConstVol, PDSS_IdealGas, and PDSS_Water.

Definition at line 181 of file PDSS.cpp.

## ◆ critTemperature()

double critTemperature | ( |  | ) | const
| virtual

critical temperature

Reimplemented in PDSS_Water.

Definition at line 137 of file PDSS.cpp.

## ◆ critPressure()

double critPressure | ( |  | ) | const
| virtual

critical pressure

Reimplemented in PDSS_Water.

Definition at line 142 of file PDSS.cpp.

## ◆ critDensity()

double critDensity | ( |  | ) | const
| virtual

critical density

Reimplemented in PDSS_Water.

Definition at line 147 of file PDSS.cpp.

## ◆ satPressure()

double satPressure | ( | double | T | ) |
| virtual

saturation pressure

Parameters

  T | Temperature (Kelvin)

Reimplemented in PDSS_ConstVol, PDSS_SSVol, and PDSS_Water.

Definition at line 186 of file PDSS.cpp.

## ◆ molecularWeight()

double molecularWeight | ( |  | ) | const

Return the molecular weight of the species in units of kg kmol-1.

Definition at line 167 of file PDSS.cpp.

## ◆ setMolecularWeight()

void setMolecularWeight | ( | double | mw | ) |

Set the molecular weight of the species.

Parameters

  mw | Molecular Weight in kg kmol-1

Definition at line 171 of file PDSS.cpp.

## ◆ setReferenceThermo()

void setReferenceThermo | ( | shared_ptr< SpeciesThermoInterpType > | stit | ) |
| inline

Set the SpeciesThermoInterpType object used to calculate reference state properties.

Definition at line 401 of file PDSS.h.

## ◆ setParent()

virtual void setParent | ( | VPStandardStateTP * | phase,
|  | size_t | k
| ) |  |
| inline virtual

Set the parent VPStandardStateTP object of this PDSS object.

This information is only used by certain PDSS subclasses

Parameters

  phase | Pointer to the parent phase
  k | Index of this species in the phase

Reimplemented in PDSS_HKFT, and PDSS_IonsFromNeutral.

Definition at line 411 of file PDSS.h.

## ◆ initThermo()

virtual void initThermo | ( |  | ) |
| inline virtual

Initialization routine.

This is a cascading call, where each level should call the the parent level.

Reimplemented in PDSS_ConstVol, PDSS_HKFT, PDSS_IdealGas, PDSS_IonsFromNeutral, and PDSS_SSVol.

Definition at line 418 of file PDSS.h.

## ◆ setParameters()

void setParameters | ( | const AnyMap & | node | ) |
| inline

Set model parameters from an AnyMap phase description, for example from the `equation-of-state` field of a species definition.

Definition at line 422 of file PDSS.h.

## ◆ getParameters()

virtual void getParameters | ( | AnyMap & | eosNode | ) | const
| inline virtual

Store the parameters needed to reconstruct a copy of this PDSS object.

Reimplemented in PDSS_ConstVol, PDSS_HKFT, PDSS_IdealGas, PDSS_IonsFromNeutral, PDSS_SSVol, and PDSS_Water.

Definition at line 427 of file PDSS.h.

## ◆ reportParams()

void reportParams | ( | size_t & | kindex,
|  | int & | type,
|  | double *const | c,
|  | double & | minTemp,
|  | double & | maxTemp,
|  | double & | refPressure
| ) |  | const
| virtual

This utility function reports back the type of parameterization and all of the parameters for the species, index.

Parameters

  kindex | Species index (unused)
  type | Integer type of the standard type (unused)
  c | Vector of coefficients used to set the parameters for the standard state.
  minTemp | output - Minimum temperature
  maxTemp | output - Maximum temperature
  refPressure | output - reference pressure (Pa).

Deprecated:
  To be removed after Cantera 3.0. Use getParameters() instead.

Reimplemented in PDSS_HKFT.

Definition at line 191 of file PDSS.cpp.

## Member Data Documentation

## ◆ m_temp

double m_temp = -1.0
| mutable protected

Current temperature used by the PDSS object.

Definition at line 449 of file PDSS.h.

## ◆ m_pres

double m_pres = -1.0
| mutable protected

State of the system - pressure.

Definition at line 452 of file PDSS.h.

## ◆ m_p0

double m_p0 = -1.0
| protected

Reference state pressure of the species.

Definition at line 455 of file PDSS.h.

## ◆ m_minTemp

double m_minTemp = -1.0
| protected

Minimum temperature.

Definition at line 458 of file PDSS.h.

## ◆ m_maxTemp

double m_maxTemp = 10000.0
| protected

Maximum temperature.

Definition at line 461 of file PDSS.h.

## ◆ m_mw

double m_mw = 0.0
| protected

Molecular Weight of the species.

Definition at line 464 of file PDSS.h.

## ◆ m_input

AnyMap m_input
| protected

Input data supplied via setParameters.

This may include parameters for different phase models, which will be used when initThermo() is called.

Definition at line 468 of file PDSS.h.

## ◆ m_spthermo

shared_ptr<SpeciesThermoInterpType> m_spthermo
| protected

Pointer to the species thermodynamic property manager.

Not used in all PDSS models.

Definition at line 472 of file PDSS.h.

The documentation for this class was generated from the following files:

- PDSS.h
- PDSS.cpp